Object subclass: #FSM
	instanceVariableNames: 'name initial final current states transitions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EA-Generated'!

!FSM methodsFor: 'as yet unclassified' stamp: 'JanTomsa 3/31/2010 18:37'!
initialize
	transitions := OrderedCollection new.
	states := OrderedCollection new.! !

!FSM methodsFor: 'as yet unclassified' stamp: 'JanTomsa 4/1/2010 12:09'!
processSignal: signal
"Fire first outgoing transition of current state whose input equals signal received.
 Set current to the result and return it"

	^current := ((current outgoing) select: 
							[ :trans | 
								trans input = signal 
							]
					) first fire.! !


!FSM methodsFor: 'accessing' stamp: 'JanTomsa 3/31/2010 18:34'!
addState: aState
	states add: aState.! !

!FSM methodsFor: 'accessing' stamp: 'JanTomsa 3/31/2010 18:52'!
addTransition: aTransition
	(transitions includes: aTransition )
		ifFalse: [ transitions add: aTransition.].
	(aTransition source outgoing) add: aTransition.
	(aTransition target incoming) add: aTransition.
	! !

!FSM methodsFor: 'accessing' stamp: 'JanTomsa 3/31/2010 18:31'!
current
	^ current! !

!FSM methodsFor: 'accessing' stamp: 'JanTomsa 3/31/2010 18:31'!
current: anObject
	^ current := anObject! !

!FSM methodsFor: 'accessing' stamp: 'JanTomsa 4/1/2010 12:25'!
final
	^ final! !

!FSM methodsFor: 'accessing' stamp: 'JanTomsa 4/1/2010 12:25'!
final: anObject
	final := anObject! !

!FSM methodsFor: 'accessing' stamp: 'JanTomsa 3/31/2010 18:31'!
initial
	^ initial! !

!FSM methodsFor: 'accessing' stamp: 'JanTomsa 3/31/2010 18:31'!
initial: anObject
	initial := anObject! !

!FSM methodsFor: 'accessing' stamp: 'JanTomsa 3/31/2010 18:31'!
name1
	^ name! !

!FSM methodsFor: 'accessing' stamp: 'JanTomsa 3/31/2010 18:31'!
name: anObject
	name := anObject! !

!FSM methodsFor: 'accessing' stamp: 'JanTomsa 3/31/2010 18:31'!
states
	^ states! !

!FSM methodsFor: 'accessing' stamp: 'JanTomsa 3/31/2010 18:31'!
states: anObject
	states := anObject! !

!FSM methodsFor: 'accessing' stamp: 'JanTomsa 3/31/2010 18:31'!
transitions
	^ transitions! !

!FSM methodsFor: 'accessing' stamp: 'JanTomsa 3/31/2010 18:31'!
transitions: anObject
	transitions := anObject! !


Object subclass: #State
	instanceVariableNames: 'name incoming outgoing'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EA-Generated'!

!State methodsFor: 'accessing' stamp: 'JanTomsa 3/31/2010 18:31'!
incoming
	^ incoming! !

!State methodsFor: 'accessing' stamp: 'JanTomsa 3/31/2010 18:31'!
incoming: anObject
	incoming := anObject! !

!State methodsFor: 'accessing' stamp: 'JanTomsa 3/31/2010 18:51'!
initialize 
	incoming := OrderedCollection new.
	outgoing := OrderedCollection new.! !

!State methodsFor: 'accessing' stamp: 'JanTomsa 3/31/2010 18:31'!
name1
	^ name! !

!State methodsFor: 'accessing' stamp: 'JanTomsa 3/31/2010 18:31'!
name: anObject
	name := anObject! !

!State methodsFor: 'accessing' stamp: 'JanTomsa 3/31/2010 18:45'!
outgoing
	^ outgoing! !

!State methodsFor: 'accessing' stamp: 'JanTomsa 3/31/2010 18:45'!
outgoing: anObject
	outgoing := anObject! !

!State methodsFor: 'accessing' stamp: 'JanTomsa 3/31/2010 18:44'!
printOn: aStream
	aStream nextPutAll: name.! !


Object subclass: #Transition
	instanceVariableNames: 'input output source target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'EA-Generated'!

!Transition methodsFor: 'accessing' stamp: 'JanTomsa 4/1/2010 12:18'!
fire
	Transcript show: output.
	 ^target! !

!Transition methodsFor: 'accessing' stamp: 'JanTomsa 4/1/2010 12:20'!
input
	^ input! !

!Transition methodsFor: 'accessing' stamp: 'JanTomsa 4/1/2010 12:21'!
input: anObject
	input := anObject! !

!Transition methodsFor: 'accessing' stamp: 'JanTomsa 4/1/2010 12:22'!
output
	^ output! !

!Transition methodsFor: 'accessing' stamp: 'JanTomsa 4/1/2010 12:22'!
output: anObject
	output := anObject! !

!Transition methodsFor: 'accessing' stamp: 'JanTomsa 3/31/2010 18:31'!
source
	^ source! !

!Transition methodsFor: 'accessing' stamp: 'JanTomsa 3/31/2010 18:31'!
source: anObject
	source := anObject! !

!Transition methodsFor: 'accessing' stamp: 'JanTomsa 3/31/2010 18:39'!
target
	^ target! !

!Transition methodsFor: 'accessing' stamp: 'JanTomsa 3/31/2010 18:39'!
target: anObject
	target := anObject! !
