Object subclass: #SimplexSolution
	instanceVariableNames: 'labels values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimplexMethod'!
!SimplexSolution commentStamp: 'JanTomsa 3/29/2010 13:35' prior: 0!
A SimplexSolution is an object representing basic solution of Linear Programming problem solved by Simplex metohod.

Instance Variables
	labels:		<ByteString>
	values:		<Array>

labels
	- labels of the values in the values Array

values
	- values of the soluiton
!


!SimplexSolution methodsFor: 'accessing' stamp: 'JanTomsa 3/29/2010 13:36'!
labels
	^ labels! !

!SimplexSolution methodsFor: 'accessing' stamp: 'JanTomsa 3/29/2010 13:36'!
labels: aByteString
	labels := aByteString
! !

!SimplexSolution methodsFor: 'accessing' stamp: 'JanTomsa 3/29/2010 13:36'!
values
	^ values! !

!SimplexSolution methodsFor: 'accessing' stamp: 'JanTomsa 3/29/2010 13:36'!
values: anArray
	values := anArray 
! !


!SimplexSolution methodsFor: 'printing' stamp: 'JanTomsa 3/29/2010 17:26'!
asPairs 
	^labels asArray collectWithIndex: 
			[ :label :index | 
				Array with: label 
						with: (values at: index) .
			].! !

!SimplexSolution methodsFor: 'printing' stamp: 'JanTomsa 3/30/2010 01:04'!
asString 

	^self asPairs inject: '' 
					into:  [ :pair1 :pair2 |
								pair1 asString , pair2 asString , Character cr asString 
							]
! !

!SimplexSolution methodsFor: 'printing' stamp: 'JanTomsa 3/29/2010 13:40'!
printOn: aStream
	aStream nextPutAll: self asString .! !


Object subclass: #SimplexTableau
	instanceVariableNames: 'm labels'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimplexMethod'!
!SimplexTableau commentStamp: 'JanTomsa 3/28/2010 23:19' prior: 0!
A MyMatrix is decorator of Matrix. Purpose: asString formatting, support for Simplex method.
Simplex method implemented according to tutorial: http://www.zweigmedia.com/RealWorld/tutorialsf4/frames4_3.html

Instance Variables
	labels:		<ByteString>
	m:		<Matrix>

labels
	- xxxxx

m
	- xxxxx
!


!SimplexTableau methodsFor: 'printing' stamp: 'JanTomsa 3/30/2010 01:01'!
asString

	| string |
	labels 
		ifNotNil: [ string := labels asString, Character cr asString. ] 
		ifNil: [ string := ''. ].
	^self rows inject: string 
				into:  [ :row1 :row2 |
							(row1 asString), (row2 asString), Character cr asString
						].
! !

!SimplexTableau methodsFor: 'printing' stamp: 'JanTomsa 3/28/2010 21:06'!
printOn: stream
	stream nextPutAll: self asString .! !


!SimplexTableau methodsFor: 'accessing' stamp: 'JanTomsa 3/28/2010 23:54'!
at: anInteger at: anInteger2
	^m at: anInteger at: anInteger2.! !

!SimplexTableau methodsFor: 'accessing' stamp: 'JanTomsa 3/28/2010 23:01'!
atColumn: anInteger
	^m atColumn: anInteger.! !

!SimplexTableau methodsFor: 'accessing' stamp: 'JanTomsa 3/28/2010 23:01'!
atRow: anInteger
	^m atRow: anInteger.! !

!SimplexTableau methodsFor: 'accessing' stamp: 'JanTomsa 3/28/2010 21:26'!
columnCount 
	^ m columnCount .! !

!SimplexTableau methodsFor: 'accessing' stamp: 'JanTomsa 3/29/2010 18:25'!
columnForLabel: aString
"First: ensure aString is included in labels"
	self assert: [ labels includesSubString: aString ].
	self assert: [ aString size = 1 ].
	^m atColumn: (labels findFirst: [ :l | l = aString]).! !

!SimplexTableau methodsFor: 'accessing' stamp: 'JanTomsa 3/29/2010 13:51'!
columns
	^(1 to: m columnCount) collect: 
									[ :i | 
										SimplexTableauColumn new: (m atColumn: i )
									].! !

!SimplexTableau methodsFor: 'accessing' stamp: 'JanTomsa 3/28/2010 21:49'!
labels
	^ labels! !

!SimplexTableau methodsFor: 'accessing' stamp: 'JanTomsa 3/29/2010 18:16'!
labels: anArray
	labels := anArray.! !

!SimplexTableau methodsFor: 'accessing' stamp: 'JanTomsa 3/28/2010 18:26'!
m
	^ m! !

!SimplexTableau methodsFor: 'accessing' stamp: 'JanTomsa 3/28/2010 18:26'!
m: anObject
	m := anObject! !

!SimplexTableau methodsFor: 'accessing' stamp: 'JanTomsa 3/28/2010 21:25'!
rowCount 
	^ m rowCount .! !

!SimplexTableau methodsFor: 'accessing' stamp: 'JanTomsa 3/28/2010 23:35'!
rows
	^(1 to: m rowCount) collect: [ :i | m atRow: i ].! !


!SimplexTableau methodsFor: 'simplex method' stamp: 'JanTomsa 3/29/2010 14:14'!
basicSolution
	^SimplexSolution new
				labels: self labels;
				values: (self columns collect: 
								[ :column | 
									column isCleared 
										ifTrue: [
													(column collectWithIndex:
																[ :a :i | 
																	a = 0 
																		ifTrue: [ 0 ]
																		ifFalse: [ (self columns last) at: i ]
																]
													) sum.
												]
										ifFalse: [ 0 ]
								]
							);
				yourself.
! !

!SimplexTableau methodsFor: 'simplex method' stamp: 'JanTomsa 3/29/2010 14:17'!
isOptimal
	^self rows last min >= 0.! !

!SimplexTableau methodsFor: 'simplex method' stamp: 'JanTomsa 3/29/2010 23:43'!
nextTableau
"
Use the pivot to clear the pivot column in the normal manner. This gives the next tableau.

"
	| x |
	"--- clear the pivot column ---"
	^self class newWithArray: 
		(self rows collect: [
			:row |
			row = self pivotRow 
				ifTrue:  [ row / self pivot ]  "only copy the pivot row"
				ifFalse: [ 
								(row at: self pivotColumnPosition) = 0
									ifTrue: [ row ]
									ifFalse: [
										row collectWithIndex: 
											[ :value :index | 
												((value  * self pivot) 
												 + ((self pivotRow at: index) 
													* (row at: self pivotColumnPosition)
													* (-1)
													)) / self  pivot 
											].
									]
							]
		])
		with: self labels.
! !


!SimplexTableau methodsFor: 'pivot related' stamp: 'JanTomsa 3/28/2010 23:54'!
pivot
	^self at: self pivotPosition y at: self pivotPosition x.! !

!SimplexTableau methodsFor: 'pivot related' stamp: 'JanTomsa 3/28/2010 23:13'!
pivotColumn
"The rule for the selecting a pivot column is this: 
Look at all the numbers in the bottom row, excluding the Answer column. 
From these, choose the negative number with the largest magnitude. 
Its column is the pivot column. (If there are two candidates, choose either one.) 
If all the numbers in the bottom row are zero or positive, then you are done, and the basic solution is the optimal solution."
	^self atColumn: (self pivotColumnPosition).! !

!SimplexTableau methodsFor: 'pivot related' stamp: 'JanTomsa 3/29/2010 00:00'!
pivotColumnLabel
	^self labels at: (self pivotColumnPosition).! !

!SimplexTableau methodsFor: 'pivot related' stamp: 'JanTomsa 3/30/2010 00:49'!
pivotColumnPosition
"The rule for the selecting a pivot column is this: 
Look at all the numbers in the bottom row, excluding the Answer column. 
From these, choose the negative number with the largest magnitude. 
Its column is the pivot column.
  (If there are two candidates, choose either one. /not so fast - see below/) 
If all the numbers in the bottom row are zero or positive, then you are done, and the basic solution is the optimal solution."
	| lastRow minimum minPositions |
	lastRow := self rows last.
	minimum := lastRow min.
	minPositions :=
		((lastRow collectWithIndex: 
					[ :a :i | 
						Array with: a with: i
					]
		) select: 
					[ :a | 
						a first = minimum 
					]
		) collect: [ :a | a last ].
	^ minPositions size = 1
			ifTrue: [ minPositions first]
			ifFalse: "If there is more then one minimum we must select one with greatest delta z"
					[ 
						((minPositions collect: 
										[ :i |  
											Array " collect deltas with their positions "
												with: ((self atColumn: i) collectWithIndex: 
																	[ :a  :index |  
																		((a = 0) | (index = self rowCount))
																			ifTrue: [0]
																			ifFalse: [
																				((self columns last) at: index) /a 
																					]
																	])	sum 
												with: i.
										]
						 ) inject: #(0 0) into: " find position with maximum delta "
								[ :x :y |
										( x first > y first )
											ifTrue:  [ x ]
											ifFalse: [ y ]
								]
						) last
					].! !

!SimplexTableau methodsFor: 'pivot related' stamp: 'JanTomsa 3/28/2010 23:53'!
pivotPosition
"
Selecting the Pivot
1) The pivot must always be a positive number. (This rules out zeros and negative numbers, such as the -3 in the bottom row.) 
2) For each positive entry b in the pivot column, compute the ratio a/b, where a is the number in the rightmost column in that row. We call this a test ratio. 
3) Of these ratios, choose the smallest one. The corresponding number b is the pivot.
"
	| minimum testRatios pivotRow |
	testRatios := (self  rows collect: [ :row | 
							((row at: self pivotColumnPosition) > 0) 
								ifTrue: [
									(row last) / (row at: self pivotColumnPosition) 
								]
							 	ifFalse: [
									10 raisedTo: 10
								].
							]).
	minimum := testRatios min.
	pivotRow := testRatios findFirst: [ :i | i = minimum ].
	^(self pivotColumnPosition)@pivotRow.! !

!SimplexTableau methodsFor: 'pivot related' stamp: 'JanTomsa 3/29/2010 03:05'!
pivotRow

	^self atRow: (self pivotPosition y).! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SimplexTableau class
	instanceVariableNames: ''!

!SimplexTableau class methodsFor: 'as yet unclassified' stamp: 'JanTomsa 3/29/2010 16:24'!
new: aMatrix

	| lab |
	lab := ByteString new.
	(1 to: aMatrix columnCount) do: 
				[ :i| 
						lab := lab , ($w asInteger + i) asCharacter asString 
				].
	^SimplexTableau new
			m: aMatrix;
			labels: lab;
			yourself.
! !

!SimplexTableau class methodsFor: 'as yet unclassified' stamp: 'JanTomsa 3/29/2010 13:49'!
new: aMatrix with: aByteString

	| mym |
	mym := SimplexTableau new.
	mym m: aMatrix.
	mym labels: aByteString.
	^mym.! !

!SimplexTableau class methodsFor: 'as yet unclassified' stamp: 'JanTomsa 3/29/2010 03:44'!
newWithArray: anArray

	| mym newm flat |
	flat := OrderedCollection new.
	anArray do: [ :a | flat addAll: a ].
	newm := Matrix new
		rows: (anArray size )
		columns: (anArray first size )
		contents: ( flat asArray ).
	mym := self new: newm.
	^mym.! !

!SimplexTableau class methodsFor: 'as yet unclassified' stamp: 'JanTomsa 3/29/2010 03:45'!
newWithArray: anArray with: aByteString

	| mym newm flat |
	flat := OrderedCollection new.
	anArray do: [ :a | flat addAll: a ].
	newm := Matrix new
		rows: (anArray size )
		columns: (anArray first size )
		contents: ( flat asArray ).
	mym := self new: newm with: aByteString.
	^mym.! !


Object subclass: #SimplexTableauColumn
	instanceVariableNames: 'values'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimplexMethod'!
!SimplexTableauColumn commentStamp: 'JanTomsa 3/29/2010 13:47' prior: 0!
A SimplexTableauColumn is xxxxxxxxx.

Instance Variables
	values:		<Array>

values
	- xxxxx
!


!SimplexTableauColumn methodsFor: 'accessing' stamp: 'JanTomsa 3/29/2010 14:13'!
at: anInteger
	^values at: anInteger.
! !

!SimplexTableauColumn methodsFor: 'accessing' stamp: 'JanTomsa 3/29/2010 14:03'!
collectWithIndex: aBlock
	^ values collectWithIndex: aBlock.! !

!SimplexTableauColumn methodsFor: 'accessing' stamp: 'JanTomsa 3/29/2010 13:52'!
first
	^ values first.! !

!SimplexTableauColumn methodsFor: 'accessing' stamp: 'JanTomsa 3/29/2010 13:56'!
isCleared
	^ (values select: [ :i | i ~= 0 ]) size = 1.! !

!SimplexTableauColumn methodsFor: 'accessing' stamp: 'JanTomsa 3/29/2010 13:47'!
values
	^ values! !

!SimplexTableauColumn methodsFor: 'accessing' stamp: 'JanTomsa 3/29/2010 13:47'!
values: anArray
	values := anArray.
! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

SimplexTableauColumn class
	instanceVariableNames: ''!

!SimplexTableauColumn class methodsFor: 'as yet unclassified' stamp: 'JanTomsa 3/29/2010 13:51'!
new: anArray
	^self new
			values: anArray.! !


Object subclass: #StandardLPProblem
	instanceVariableNames: 'primaryTableau'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimplexMethod'!
!StandardLPProblem commentStamp: 'JanTomsa 3/29/2010 16:10' prior: 0!
A StandardLPProblem is xxxxxxxxx.

Here is a summary of the simplex method for standard linear programming problems.

Step1: Using slack variables, convert the LP problem to a system of linear equations.
Step 2: Set up the initial tableau.
Step 3: Select the pivot column.
The rule for the selecting a pivot column is this: Look at all the numbers in the bottom row, excluding the Answer column. From these, choose the negative number with the largest magnitude. Its column is the pivot column. (If there are two candidates, choose either one.) If all the numbers in the bottom row are zero or positive, then you are done, and the basic solution is the optimal solution.
Step 4: Select the pivot in the pivot column.
1) The pivot must always be a positive number. (This rules out zeros and negative numbers.) 
2) For each positive entry b in the pivot column, compute the ratio a/b, where a is the number in the rightmost column in that row. We call this a test ratio. 
3) Of these ratios, choose the smallest one. The corresponding number b is the pivot.
Step 5: Use the pivot to clear the pivot column in the normal manner. This gives the next tableau.
(For quick instructions on how to pivot, press here.)
Step 6: Repeat Steps 3-5 until there are no more negative numbers in the bottom row (with the possible exception of the Answer column).
The solution for the LP problem is then the basic solution associated with the final tableau.


Instance Variables

!


!StandardLPProblem methodsFor: 'accessing' stamp: 'JanTomsa 3/29/2010 16:11'!
primaryTableau
	^ primaryTableau! !

!StandardLPProblem methodsFor: 'accessing' stamp: 'JanTomsa 3/29/2010 16:11'!
primaryTableau: aSimplexTableau
	primaryTableau := aSimplexTableau.
! !


!StandardLPProblem methodsFor: 'as yet unclassified' stamp: 'JanTomsa 3/29/2010 16:31'!
solution
	| currentTableau |
	currentTableau := primaryTableau .
	[ currentTableau isOptimal ] 
		whileFalse: [ currentTableau := currentTableau nextTableau ].
	^currentTableau basicSolution.! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

StandardLPProblem class
	instanceVariableNames: ''!

!StandardLPProblem class methodsFor: 'as yet unclassified' stamp: 'JanTomsa 3/29/2010 16:22'!
new: aSimplexTableau

	^self new
		primaryTableau: aSimplexTableau;
		yourself.! !
